// getlongest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "tree.h"
#include <iostream>

#define MAX(X, Y) (((X) > (Y)) ? (X) : (Y))

template <typename T>
unsigned int computeHeight<T>::getHeight(Node<T> * root)
{
	unsigned int lh, lr, max;
	Map::const_iterator it;

	if ((root == NULL) || ((root->left == NULL) && (root->right == NULL)))
		return 0;
	else
	{
		if ((it = _m.find(root)) == _m.end())                  // not already computed and memoized?
		{
			lh = getHeight(root->left);
			lr = getHeight(root->right);
			max = MAX( lh, lr ) + 1;
			_m[root] = max;
		}

		std::cout << "heigh node" << root->val << " is=" << _m[root] << std::endl;

		return _m[root];
	}                                       
};

template <typename T>
void getLongestPath(Node<T> * root, unsigned int & longestSoFar, computeHeight<T> & ch)
{
	// for each node the longest path can be either all left, or all right, or left+right [+1 for current node)

	unsigned int lh = ch.getHeight(root->left);
	unsigned int lr = ch.getHeight(root->right);
	unsigned int lenghtCurrentNodeInMiddle = lh+lr+1;
	if (lenghtCurrentNodeInMiddle > longestSoFar)
		longestSoFar = lenghtCurrentNodeInMiddle;
	else
	{
		if (lh + 1 > longestSoFar)
			longestSoFar = lh + 1;
		if (lr + 1 > longestSoFar)
			longestSoFar = lr + 1 ;
	}

	std::cout << "lenght longest path node=" << root->val << " is=" << longestSoFar << std::endl;

	if (root->left)
		getLongestPath(root->left, longestSoFar, ch);
	if (root->right)
		getLongestPath(root->right, longestSoFar, ch);
};

int main(int argc, char* argv[])
{
	typedef Node<int> NI;
	NI * root = new NI(0);                  // 0                          0
	root->left  = new NI(1);                // 1                       1     2
    root->right = new NI(2);                // 1
	root->left->right = new NI(4);          // 2                          4
	root->left->right->left = new NI(5);    // 3                       5

	NI * root2 = new NI(0);                 // 0                        0                    
	root2->left = new NI(1);                // 1                     1 
	root2->left->left = new NI(2);          // 2                  2
  	root2->left->left->left = new NI(3);    // 3               3
	root2->left->left->left->right = new NI(4);    // 4          4


	computeHeight<int> ch;
	unsigned int h = ch.getHeight(root);
	std::cout << h;
	
	unsigned int longestSoFar = 0;
	getLongestPath(root, longestSoFar, ch);
	std::cout << " longestPath=" << longestSoFar << std::endl;

	getLongestPath(root2, longestSoFar, ch);
	std::cout << " longestPath=" << longestSoFar << std::endl;


	int i;
	std::cin >> i;
	return 0;
}

