#ifndef TREE_H
#define TREE_H 1

#include <map>

template <typename T>
struct Node
{
	Node<T> * left;
	Node<T> * right;
	T val;
	Node(T v): val(v), left(NULL), right(NULL) {};
};

template <typename T>
class computeHeight
{
public: 
	computeHeight(){};

	unsigned int getHeight(Node<T> * root);

private:
	typedef std::map<Node<T> *, unsigned int> Map;
	Map _m; //map to memoize the results
};


template <typename T>
void getLongestPath(Node<T> * root, unsigned int & longestSoFar, computeHeight<T> & ch);

#endif